;************************************************************************************
;
; Microbot ROM bit correct disassembly - Lee Davison 09/2011

LAB_00	= $00			; Rx buffer to $7F

LAB_80	= $80			;.
LAB_81	= $81			;.
LAB_82	= $82			;.
LAB_83	= $83			;.
LAB_84	= $84			;.
LAB_85	= $85			;.
LAB_86	= $86			;.
LAB_87	= $87			;.
LAB_88	= $88			;.
LAB_89	= $89			;.
LAB_8A	= $8A			;.
LAB_8B	= $8B			; Rx buffer write index
LAB_8C	= $8C			; Rx buffer read index
LAB_8D	= $8D			;.
LAB_8E	= $8E			;.
LAB_8F	= $8F			;.
LAB_90	= $90			;.
LAB_91	= $91			;.
LAB_92	= $92			;.
LAB_94	= $94			;.
LAB_95	= $95			;.
LAB_96	= $96			;.
LAB_97	= $97			;.
LAB_98	= $98			;.
LAB_99	= $99			;.
LAB_9A	= $9A			;.
LAB_9B	= $9B			;.
LAB_9C	= $9C			;.
LAB_9D	= $9D			;.
LAB_9E	= $9E			;.
LAB_9F	= $9F			;.
LAB_A0	= $A0			; RAM end low byte
LAB_A1	= $A1			; RAM end high byte
LAB_A2	= $A2			;.
LAB_A3	= $A3			;.
LAB_A4	= $A4			;.
LAB_A5	= $A5			;.
LAB_A6	= $A6			;.
LAB_A8	= $A8			;.
LAB_A9	= $A9			;.
LAB_AA	= $AA			;.
LAB_00AB	= $00AB		;.
LAB_AC	= $AC			;.
LAB_AD	= $AD			;.
LAB_B3	= $B3			;.
LAB_00B7	= $00B7		;.
LAB_B9	= $B9			;.
LAB_BB	= $BB			;.
LAB_BC	= $BC			;.
LAB_BD	= $BD			;.
LAB_BE	= $BE			;.
LAB_BF	= $BF			;.
LAB_C4	= $C4			;.
LAB_C5	= $C5			;.
LAB_CB	= $CB			;.
LAB_D1	= $D1			;.
LAB_D7	= $D7			;.
LAB_DD	= $DD			;.
LAB_E3	= $E3			;.
LAB_E4	= $E4			;.
LAB_E5	= $E5			;.
LAB_E6	= $E6			;.
LAB_E7	= $E7			;.
LAB_E8	= $E8			;.
LAB_E9	= $E9			;.

LAB_0119	= $0119		; top of stack
LAB_011A	= $011A		; start of data ?? RAM

LAB_0400	= $0400		; RAM end for 1K RAM

LAB_07FE	= $07FE		; RAM end for 2K RAM, this makes a whole number of $0E
					; sized blocks
LAB_07FF	= $07FF		; test address for 2K RAM


;************************************************************************************
;
; 74LS174 hex D-type flip flops

; these are probably wired with 4 bits all going to d7-d4 and a pair of bits from flip
; flops 0 and 2 going to two of d3-d0 and a pair of bits from flip flops 1 and 3 going
; to the other two of d3-d0

LAB_0800	= $0800		; 74LS174 hex D-type flip flop 0, echoed to $0BFF
LAB_0C00	= $0C00		; 74LS174 hex D-type flip flop 1, echoed to $0FFF
LAB_1000	= $1000		; 74LS174 hex D-type flip flop 2, echoed to $1FFF
LAB_1400	= $1400		; 74LS174 hex D-type flip flop 3, echoed to $17FF


;************************************************************************************
;
; 74LS251 8 input data selector, echoed to $1BFF
;
; bit n is addressed at LAB_180n

LAB_1800	= $1800		;.


;************************************************************************************
;
; 74LS259 8 bit addressable latch, echoed to $1FFF
;
; bit n is addressed at LAB_1C0n

LAB_1C00	= $1C00		;.
LAB_1C06	= $1C06		;.
LAB_1C07	= $1C07		;.


;************************************************************************************


; all of this address map is most likely echoed in the following 8K block so the
; 74LS251, 8 input data selector, probably also appears at $3C00


;************************************************************************************
;
; MC6850 asynchronous communications interface adapters, echoed from $4000 to $7FFF ??

LAB_4800	= $4800		; ACIA A status port
LAB_4801	= $4801		; ACIA A data port

LAB_5000	= $5000		; ACIA B status port
LAB_5001	= $5001		; ACIA B data port


;************************************************************************************
;
; R6522 versatile interface adapter, echoed from $4000 to $7FFF ??

LAB_7800	= $7800		; VIA DRB
LAB_7801	= $7801		; VIA DRA
LAB_7802	= $7802		; VIA DDRB
LAB_7803	= $7803		; VIA DDRA
LAB_7804	= $7804		; VIA T1Cl
LAB_7805	= $7805		; VIA T1Ch
LAB_7806	= $7806		; VIA T1Ll
LAB_7807	= $7807		; VIA T1Lh
LAB_7808	= $7808		; VIA T2Cl
LAB_780A	= $780A		; VIA SR
LAB_780B	= $780B		; VIA ACR
LAB_780C	= $780C		; VIA PCR
LAB_780E	= $780E		; VIA IER


;************************************************************************************
;
; system ROM, echoed from $8000

	.ORG	$F000			; ROM start

;LAB_F000:
	.byte	"(C) MICROBOT INC. 1982"		;.

LAB_F016:
	.byte	$3F,$2E,$5E,$2E	;.
	.byte	$16,$0A,$04,$01	;.

LAB_F01E:
	.byte	$00,$01,$02		;.
	.byte	$03,$04,$FA,$FB	;.
	.byte	$05,$06,$07,$08	;.
	.byte	$09,$FD,$FE		;.

LAB_F02C:
	.byte	$FF,$90,$60,$48	;.
	.byte	$32			;.

LAB_F031:
	.byte	$22,$17,$13,$11	;.
	.byte	$10,$0F,$0E,$0D	;.
	.byte	$0C,$0B,$0A		;.


;************************************************************************************
;
; RESET vector

LAB_F03C:
	LDA	#$40			; set IOII IIII
	STA	LAB_7802		; VIA DDRB
	LDA	#$00			; set all inputs
	STA	LAB_7803		; VIA DDRA
	STA	LAB_7800		; VIA DRB
	LDA	#$50			; T1 continuous interrupts, T2 timed interrupt, shift out
					; free run at T2 rate, PB latch disable, PA latch disable
	STA	LAB_780B		; VIA ACR
	LDA	#$EE			; CB2 high, CB1 negative edge, CA2 high, CA1 negative edge
	STA	LAB_780C		; VIA PCR
	LDA	LAB_7800		; VIA DRB
	AND	#$07			;.
	TAX				;.
	LDA	LAB_F016,X		;.
	STA	LAB_7808		; VIA T2Cl
	LDA	#$AA			;.
	CPX	#$02			;.
	BCS	LAB_F067		;.

	LDA	#$0F			;.
LAB_F067:
	STA	LAB_780A		; VIA SR

; setup the 6850 ACIAs

	LDA	#$03			; soft reset
	STA	LAB_4800		; reset ACIA A
	STA	LAB_5000		; reset ACIA B
	LDA	#$95			; setup for interrupts enabled, 8N1, clock\16
	STA	LAB_4800		; set ACIA A
	STA	LAB_5000		; set ACIA B

; clear LAB_80 to LAB_E9

	LDA	#$00			; clear A
	LDX	#LAB_E9		; set the start address
LAB_F07E:
	STA	LAB_00,X		; clear a zero page byte
	DEX				; decrement the index
	BMI	LAB_F07E		; loop if more to do

; set the RAM top

	LDX	#<LAB_0400		; set the 1K RAM end low byte
	LDY	#>LAB_0400		; set the 1K RAM end high byte
	STY	LAB_07FF		; save the test byte
	CPY	LAB_07FF		; test the test byte
	BNE	LAB_F093		; if the test failed skip the 2K RAM set

	LDX	#<LAB_07FE		; set the 2K RAM end low byte
	LDY	#>LAB_07FE		; set the 2K RAM end high byte
LAB_F093:
	STX	LAB_A0		; save the RAM end low byte
	STY	LAB_A1		; save the RAM end high byte

; the stack pointer isn't set yet and the following subroutine writes over parts of page
; one, the stack page

	JSR	LAB_F15D		; clear every $0Eth byte ??

; fill LAB_E3 to LAB_E8 inclusive with $01

	LDA	#$01			; set the fill byte
	LDX	#$05			; set the byte count/index
LAB_F09E:
	STA	LAB_E3,X		; fill a byte
	DEX				; decrement byte the count/index
	BPL	LAB_F09E		; loop if more to do

	LDA	#$40			;.
	STA	LAB_88		;.

	LDX	#$07			; set the byte count/index
LAB_F0A9:
	STA	LAB_1C00,X		;.
	DEX				; decrement byte the count/index
	BPL	LAB_F0A9		; loop if more to do

	LDA	#$FF			;.
	STA	LAB_7804		; VIA T1Cl
	LDA	LAB_F031		;.
	STA	LAB_AC		;.
	LDA	#$C0			;.
	STA	LAB_780E		; VIA IER

; main loop ??

LAB_F0BE:
	LDX	#<LAB_0119		; set the stack address low byte
	TXS				; set the stack pointer
	CLI				; enable interrupts
LAB_F0C2:
	LDA	#$F1			;.
LAB_F0C4:
	STA	LAB_1C00		;.
	STA	LAB_1C07		;.
LAB_F0CA:
	LDX	LAB_83		;.
	BNE	LAB_F0CA		;.

	STA	LAB_80		;.
	CMP	#$F1			;.
	BNE	LAB_F0D9		;.

	LDA	#$00			;.
	STA	LAB_1C06		;.
LAB_F0D9:
	LDA	LAB_AC		;.
	JSR	LAB_F848		;..
LAB_F0DE:
	LDA	LAB_86		;.
	BEQ	LAB_F0E5		;.

	JMP	LAB_F2C4		;.

LAB_F0E5:
	JSR	LAB_F9A8		;..
	BEQ	LAB_F0DE		;.

	LDX	#$01			;.
	STX	LAB_1C06		;.
	LDX	LAB_9A		;.
	BEQ	LAB_F0FA		;.

	LDX	#$00			;.
	STX	LAB_9A		;.
	JMP	LAB_F475		;.

LAB_F0FA:
	EOR	#$07			;.
	BNE	LAB_F102		;.

	STA	LAB_83		;.
	BEQ	LAB_F120		;.

LAB_F102:
	LDY	#$0D			;.
LAB_F104:
	LDA	LAB_00AB,Y		;.
	STA	(LAB_8D),Y		;.
	DEY				;.
	BNE	LAB_F104		;.

	LDA	#$01			;.
	STA	(LAB_8D),Y		;.
	JSR	LAB_F1CF		; increment the LAB_8D pointer by $000E ??
	STA	LAB_9F		;.
	BNE	LAB_F0C2		;.

LAB_F117:
	LDA	#$01			;.
	STA	LAB_1C00		;.
LAB_F11C:
	LDA	LAB_83		;.
	BNE	LAB_F11C		;.

LAB_F120:
	LDX	#$01			;.
	STX	LAB_1C07		;.
	STX	LAB_1C06		;.
	STX	LAB_7800		; VIA DRB
	DEX				;.
	STX	LAB_1C00		;.
	STX	LAB_80		;.
LAB_F131:
	JSR	LAB_F9A8		;..
	BNE	LAB_F13D		;.

	LDA	LAB_86		;.
	BEQ	LAB_F131		;.

	JMP	LAB_F2C4		;.

LAB_F13D:
	CMP	#$07			;.
	BNE	LAB_F175		;.

LAB_F141:
	LDA	LAB_83		;.
	BEQ	LAB_F131		;.

	LDA	LAB_A3		;.
	CMP	#$EF			;.
	BEQ	LAB_F155		;.

	CMP	#$F7			;.
	BNE	LAB_F141		;.

	JSR	LAB_F15D		; clear every $0Eth byte ??
LAB_F152:
	JMP	LAB_F117		;.

LAB_F155:
	JSR	LAB_F995		; set LAB_8D pointer to LAB_011A ??
	JSR	LAB_F29F		;..
	BMI	LAB_F152		;.


;************************************************************************************
;
; clear every $0Eth byte ??

LAB_F15D:
	JSR	LAB_F995		; set LAB_8D pointer to LAB_011A ??
	LDY	#$00			; clear Y
LAB_F162:
	TYA				; clear A
	STA	(LAB_8D),Y		; clear ?? byte
	JSR	LAB_F1CF		; increment the LAB_8D pointer by $000E ??
	LDA	LAB_8D		;.
	CMP	#<LAB_011A		; ?? low byte
	BNE	LAB_F162		;.

	LDA	LAB_8E		;.
	CMP	#>LAB_011A		; ?? high byte
	BNE	LAB_F162		;.

	RTS


;************************************************************************************
;
; ??

LAB_F175:
	CMP	#$0D			;.
	BNE	LAB_F189		;.

	JSR	LAB_F914		;..
	AND	#$0F			;.
	TAX				;.
	LDA	LAB_F02C,X		;.
	STA	LAB_AC		;.
	JSR	LAB_F848		;..
	BNE	LAB_F120		;.

LAB_F189:
	CMP	#$04			;.
	BNE	LAB_F1EA		;.

	LDY	#$00			;.
	LDA	#$05			;.
	STA	(LAB_8D),Y		;.
	JSR	LAB_F914		;..
	LDY	#$01			;.
	STA	(LAB_8D),Y		;.
	JSR	LAB_F914		;..
	LDY	#$02			;.
	STA	(LAB_8D),Y		;.
	DEY				;.
	LDA	(LAB_8D),Y		;.
	TAX				;.
	LDA	LAB_84		;.
	JSR	LAB_F1B4		;..
LAB_F1AA:
	JSR	LAB_F1CF		; increment the LAB_8D pointer by $000E ??
LAB_F1AD:
	LDY	#$FF			;.
	STY	LAB_9F		;.
	JMP	LAB_F120		;.


;************************************************************************************
;
; ??

LAB_F1B4:
	CPX	#$08			;.
	BNE	LAB_F1C1		;.

	ROR				;.
	ROR				;.
	ROR				;.
	AND	#$40			;.
	STA	LAB_7800		; VIA DRB
	RTS

LAB_F1C1:
	CPX	#$00			;.
	BEQ	LAB_F1C9		;.

	CPX	#$06			;.
	BCC	LAB_F1CB		;.

LAB_F1C9:
	EOR	#$FF			;.
LAB_F1CB:
	STA	LAB_1C00,X		;.
	RTS


;************************************************************************************
;
; increment the LAB_8D pointer by $000E ??

LAB_F1CF:
	CLC				; clear carry for add
	LDA	LAB_8D		;.
	ADC	#$0E			;.
	STA	LAB_8D		;.
	BCC	LAB_F1DC		;.

	INC	LAB_8E		;.
	LDA	LAB_8D		;.
LAB_F1DC:
	CMP	LAB_A0		; compare it with the RAM end low byte
	BNE	LAB_F1E9		;.

	LDA	LAB_8E		;.
	CMP	LAB_A1		; compare it with the RAM end high byte
	BNE	LAB_F1E9		;.

	JSR	LAB_F995		; set LAB_8D pointer to LAB_011A ??
LAB_F1E9:
	RTS


;************************************************************************************
;
; ??

LAB_F1EA:
	CMP	#$02			;.
	BNE	LAB_F1FE		;.

	LDY	#$00			;.
	LDA	#$04			;.
	STA	(LAB_8D),Y		;.
	JSR	LAB_F914		;..
	LDY	#$01			;.
	STA	(LAB_8D),Y		;.
	JMP	LAB_F1AA		;.

LAB_F1FE:
	CMP	#$0A			;.
	BNE	LAB_F21E		;.

	LDY	#$00			;.
	LDA	#$03			;.
	STA	(LAB_8D),Y		;.
	JSR	LAB_F914		;..
	LDY	#$01			;.
	STA	(LAB_8D),Y		;.
	JSR	LAB_F914		;..
	LDY	#$02			;.
	STA	(LAB_8D),Y		;.
	INY				;.
	LDA	LAB_85		;.
	STA	(LAB_8D),Y		;.
	JMP	LAB_F1AA		;.

LAB_F21E:
	CMP	#$06			;.
	BNE	LAB_F227		;.

	LDA	#$FF			;.
	JMP	LAB_F0C4		;.

LAB_F227:
	CMP	#$01			;.
	BNE	LAB_F22E		;.

	JMP	LAB_F0C2		;.

LAB_F22E:
	CMP	#$0E			;.
	BNE	LAB_F250		;.

LAB_F232:
	LDY	#$01			;.
	STY	LAB_1C00		;.
	DEY				;.
	STY	LAB_1C07		;.
LAB_F23B:
	JSR	LAB_F737		;..
	JSR	LAB_F9A8		;..
	CMP	#$07			;.
	BEQ	LAB_F29C		;.

	CMP	#$0E			;.
	BEQ	LAB_F29C		;.

	LDA	LAB_86		;.
	BEQ	LAB_F23B		;.

	JMP	LAB_F2C4		;.

LAB_F250:
	CMP	#$08			;.
	BNE	LAB_F263		;.

	LDY	#$01			;.
	STY	LAB_1C00		;.
	DEY				;.
	STY	LAB_1C07		;.
	JSR	LAB_F737		;..
	JMP	LAB_F11C		;.

LAB_F263:
	CMP	#$05			;.
	BNE	LAB_F27C		;.

	JSR	LAB_F26D		; clear all the 74LS174 hex D-type flip flops
	JMP	LAB_F117		;.


;************************************************************************************
;
; clear all the 74LS174 hex D-type flip flops

LAB_F26D:
	LDA	#$00			; clear A
	STA	LAB_0800		; clear 74LS174 hex D-type flip flop 0
	STA	LAB_0C00		; clear 74LS174 hex D-type flip flop 1
	STA	LAB_1000		; clear 74LS174 hex D-type flip flop 2
	STA	LAB_1400		; clear 74LS174 hex D-type flip flop 3
	RTS


;************************************************************************************
;
; ??

LAB_F27C:
	CMP	#$03			;.
	BNE	LAB_F2B5		;.

	LDY	#$00			;.
	STY	LAB_1C07		;.
	LDA	#$02			;.
	STA	(LAB_8D),Y		;.
	INY				;.
	STY	LAB_1C00		;.
	LDA	LAB_AC		;.
	STA	(LAB_8D),Y		;.
	JSR	LAB_F96D		;..
	JSR	LAB_F1CF		; increment the LAB_8D pointer by $000E ??
	STA	LAB_9F		;.
	JMP	LAB_F11C		;.

LAB_F29C:
	JMP	LAB_F120		;.


;************************************************************************************
;
; ??

LAB_F29F:
	LDX	#$05			;.
LAB_F2A1:
	CLC				; clear carry for add
	LDA	LAB_DD,X		;.
	ADC	LAB_AD,X		;.
	STA	LAB_DD,X		;.
	DEX				;.
	BPL	LAB_F2A1		;.

	LDA	#$00			;.
	LDX	#$0B			;.
LAB_F2AF:
	STA	LAB_AD,X		;.
	DEX				;.
	BPL	LAB_F2AF		;.

	RTS

LAB_F2B5:
	CMP	#$09			;.
	BNE	LAB_F29C		;.

	JSR	LAB_F914		;..
	LDX	LAB_85		;.
	JSR	LAB_F797		;..
	JMP	LAB_F1AD		;.

LAB_F2C4:
	LDA	#$00			;.
	STA	LAB_86		;.
LAB_F2C8:
	JSR	LAB_F9B3		; get a byte from the buffer ??
	CMP	LAB_88		;.
	BNE	LAB_F2C8		;.

	LDA	LAB_AA		;.
	BEQ	LAB_F2D9		;.

	LDA	#$00			;.
	STA	LAB_AA		;.
	BEQ	LAB_F300		;.

LAB_F2D9:
	LDY	#$02			;.
LAB_F2DB:
	JSR	LAB_F9B3		; get a byte from the buffer ??
	CMP	LAB_88		;.
	BEQ	LAB_F2D9		;.

	AND	#$7F			;.
	CMP	#$0D			;.
	BEQ	LAB_F300		;.

	DEY				;.
	BPL	LAB_F2DB		;.

	CMP	#$4D			;.
	BNE	LAB_F317		;.

LAB_F2EF:
	JSR	LAB_F9B3		; get a byte from the buffer ??
	CMP	LAB_88		;.
	BEQ	LAB_F2D9		;.

	AND	#$7F			;.
	CMP	#$20			;.
	BEQ	LAB_F30B		;.

	CMP	#$0D			;.
	BNE	LAB_F2EF		;.

LAB_F300:
	DEC	LAB_8C		; decrement the Rx buffer read index
	LDA	LAB_8C		; get the Rx buffer read index
	AND	#$7F			;.
	STA	LAB_8C		; save the Rx buffer read index
	JMP	LAB_F46E		;.

LAB_F30B:
	JSR	LAB_F9B3		; get a byte from the buffer ??
	CMP	#$0D			;.
	BEQ	LAB_F300		;.

	STA	LAB_88		;.
LAB_F314:
	JMP	LAB_F475		;.

LAB_F317:
	INY				;.
	STY	LAB_80		;.
	CMP	#$4F			;.
	BNE	LAB_F329		;.

	JSR	LAB_F8ED		;..
	LDA	#$01			;.
	JSR	LAB_F96F		;..
	JMP	LAB_F363		;.

LAB_F329:
	CMP	#$45			;.
	BNE	LAB_F36C		;.

	JSR	LAB_F8ED		;..
	LDX	#$00			;.
LAB_F332:
	STX	LAB_9B		;.
	JSR	LAB_F859		;..
	LDX	LAB_9B		;.
	STY	LAB_B9,X		;.
	STA	LAB_BF,X		;.
	INX				;.
	CPX	#$06			;.
	BCC	LAB_F332		;.

	LDA	LAB_9C		;.
	BEQ	LAB_F35E		;.

	JSR	LAB_F859		;..
	ROR				;.
	ROR				;.
	ROR				;.
	AND	#$40			;.
	STA	LAB_7800		; VIA DRB

	LDX	#$07			; set the bit count/index
	TYA				;.
	EOR	#$C1			; toggle xx.. ...x bits
	ROL				; shift bit 7 to carry
LAB_F357:
	ROL				; shift next bit to bit 0
	STA	LAB_1C00,X		; save the bit to the addressable latch
	DEX				; decrement the bit count/index
	BPL	LAB_F357		; loop if more to do

LAB_F35E:
	STX	LAB_A4		;.
	JSR	LAB_F502		;..
LAB_F363:
	CMP	#$07			;.
	BNE	LAB_F314		;.

	LDX	#$32			;.
	JMP	LAB_F470		;.

LAB_F36C:
	CMP	#$41			;.
	BNE	LAB_F3A5		;.

	JSR	LAB_F47F		;..
	LDX	#$00			;.
LAB_F375:
	STX	LAB_9B		;.
	LDY	LAB_AD,X		;.
	LDA	LAB_B3,X		;.
	JSR	LAB_F9BF		;..
	LDX	#','			; set ","
	JSR	LAB_F8FC		; send ACIA A byte with delay
	LDX	LAB_9B		;.
	INX				;.
	CPX	#$06			;.
	BCC	LAB_F375		;.

	LDX	#$07			; set the bit count/index
LAB_F38C:
	LDA	LAB_1800,X		; read the 74LS251 data selector bit X
	ASL				; shift it out to the carry ..
	ROL	LAB_97		; .. and into the data selector byte
	DEX				; decrement the bit count/index
	BPL	LAB_F38C		; loop if more to do

	LDA	LAB_97		;.
	EOR	#$FF			;.
	TAY				;.
	LDA	LAB_82		;.
	INX				;.
	STX	LAB_82		;.
	JSR	LAB_F9BF		;..
	JMP	LAB_F469		;.

LAB_F3A5:
	CMP	#$54			;.
	BNE	LAB_F3B9		;.

	JSR	LAB_F8ED		;..
	STA	LAB_9A		;.
	LDA	LAB_A6		;.
	STA	LAB_A8		;.
	LDA	#$F1			;.
	STA	LAB_80		;.
	JMP	LAB_F0E5		;.

LAB_F3B9:
	CMP	#$53			;.
	BNE	LAB_F3CD		;.

	LDA	#$00			;.
	STA	LAB_80		;.
	JSR	LAB_F26D		; clear all the 74LS174 hex D-type flip flops
	JSR	LAB_F29F		;..
	JSR	LAB_F47F		;..
	JMP	LAB_F120		;.

LAB_F3CD:
	CMP	#$4C			;.
	BNE	LAB_F3D9		;.

	JSR	LAB_F859		;..
	STY	LAB_A2		;.
	JMP	LAB_F475		;.

LAB_F3D9:
	CMP	#$55			;.
	BNE	LAB_F42D		;.

	JSR	LAB_F47F		;..
	JSR	LAB_F995		; set LAB_8D pointer to LAB_011A ??
	LDX	#$00			;.
	STX	LAB_94		;.
LAB_F3E7:
	LDA	#$07			;.
	STA	LAB_9B		;.
	LDY	LAB_94		;.
	LDA	#$00			;.
	JSR	LAB_F9BF		;..
	LDX	#','			; set ","
	JSR	LAB_F8FC		; send ACIA A byte with delay
LAB_F3F7:
	LDX	#$00			;.
	LDA	(LAB_8D,X)		;.
	TAY				;.
	INC	LAB_8D		;.
	LDA	(LAB_8D,X)		;.
	JSR	LAB_F9BF		;..
	INC	LAB_8D		;.
	BNE	LAB_F409		;.

	INC	LAB_8E		;.
LAB_F409:
	DEC	LAB_9B		;.
	BEQ	LAB_F414		;.

	LDX	#','			; set ","
	JSR	LAB_F8FC		; send ACIA A byte with delay
	BNE	LAB_F3F7		;.

LAB_F414:
	LDX	#$0D			; set [CR]
	JSR	LAB_F8FC		; send ACIA A byte with delay
	INC	LAB_94		;.
	LDA	LAB_8D		;.
	CMP	LAB_A0		; compare it with the RAM end low byte
	BNE	LAB_F3E7		;.

	LDA	LAB_8E		;.
	CMP	LAB_A1		; compare it with the RAM end high byte
	BNE	LAB_F3E7		;.

	JSR	LAB_F995		; set LAB_8D pointer to LAB_011A ??
	JMP	LAB_F478		;.

LAB_F42D:
	CMP	#$52			;.
	BNE	LAB_F457		;.

	JSR	LAB_F859		;..
	TAX				;.
	TYA				;.
	JSR	LAB_F797		;..
	LDY	#$00			;.
LAB_F43B:
	STY	LAB_9B		;.
	JSR	LAB_F859		;..
	PHA				;.
	TYA				;.
	LDY	LAB_9B		;.
	STA	(LAB_8D),Y		;.
	INC	LAB_9B		;.
	LDY	LAB_9B		;.
	PLA				;.
	STA	(LAB_8D),Y		;.
	LDY	LAB_9B		;.
	INY				;.
	CPY	#$0E			;.
	BCC	LAB_F43B		;.

	JMP	LAB_F475		;.

LAB_F457:
	CMP	#$4E			;.
	BNE	LAB_F46E		;.

	JSR	LAB_F859		;..
	TAX				;.
	TYA				;.
	JSR	LAB_F797		;..
	JSR	LAB_F47F		;..
	JMP	LAB_F232		;.

LAB_F469:
	JSR	LAB_F494		; send [CR] via ACIA A byte with delay
	BNE	LAB_F478		;.

LAB_F46E:
	LDX	#'0'			; set "0"
LAB_F470:
	JSR	LAB_F481		;..
	BNE	LAB_F478		;.

LAB_F475:
	JSR	LAB_F47F		;..
LAB_F478:
	LDA	#$F1			;.
	STA	LAB_80		;.
	JMP	LAB_F0D9		;.


;************************************************************************************
;
; ??

LAB_F47F:
	LDX	#'1'			; set "1"


;************************************************************************************
;
; ??

LAB_F481:
	JSR	LAB_F8FC		; send ACIA A byte with delay
	LDX	LAB_8C		; get the Rx buffer read index
	LDA	LAB_00,X		; get an Rx buffer byte
LAB_F488:
	AND	#$7F			; mast 0xxx xxxx, 7 bit ASCII
	CMP	#$0D			; compare the byte with [CR]
	BEQ	LAB_F494		; if [CR] go echo the character and return

	JSR	LAB_F9B3		; get a byte from the buffer ??
	JMP	LAB_F488		; loop for the next byte


;************************************************************************************
;
; send [CR] via ACIA A byte with delay

LAB_F494:
	LDX	#$0D			; set [CR]
	JMP	LAB_F8FC		; send ACIA A byte with delay


;************************************************************************************
;
; IRQ vector

LAB_F499:
	PHA				; save A
	TXA				; copy X
	PHA				; save X

	LDA	LAB_4800		; read ACIA A status
	BMI	LAB_F4B8		;.

	LDA	LAB_5000		; read ACIA B status
	AND	#$7C			;.
	BNE	LAB_F4B2		;.

	LDX	LAB_5001		; read the ACIA B Rx data byte 
	CLI				; enable interrupts
	JSR	LAB_F909		; send ACIA A byte
	JMP	LAB_F4CF		; restore X and A and return from interrupt

LAB_F4B2:
	LDA	LAB_5001		; read the ACIA B Rx data byte
	JMP	LAB_F4CF		; restore X and A and return from interrupt

LAB_F4B8:
	AND	#$7C			;.
	BNE	LAB_F4D2		;.

	LDA	LAB_4801		; read the ACIA A Rx data byte
	CMP	LAB_88		;.
	BNE	LAB_F4DD		;.

	DEC	LAB_87		;.
LAB_F4C5:
	LDX	LAB_8B		; get the Rx buffer write index
	STA	LAB_00,X		; save the received byte
	INX				; increment the Rx buffer write index
	TXA				; copy it
	AND	#$7F			; mask 0xxx xxxx
	STA	LAB_8B		; save the Rx buffer write index
LAB_F4CF:
	JMP	LAB_F719		; restore X and A and return from interrupt

LAB_F4D2:
	LDX	LAB_4801		;.
	BIT	LAB_87		;.
	BPL	LAB_F4CF		; if ?? restore X and A and return from interrupt

	STA	LAB_AA		;.
	BMI	LAB_F4CF		; if ?? restore X and A and return from interrupt

LAB_F4DD:
	BIT	LAB_87		;.
	BMI	LAB_F4F0		;.

	CLI				; enable interrupts
	TAX				; copy the Tx data byte
	LDA	#$02			; mask 0000 00x0, ACIA B Tx status bit
LAB_F4E5:
	BIT	LAB_5000		; test the ACIA B Tx status bit
	BEQ	LAB_F4E5		; loop while the Tx buffer is full

	STX	LAB_5001		; save the ACIA B Tx data byte
	JMP	LAB_F4CF		; restore X and A and return from interrupt

LAB_F4F0:
	CMP	#$0D			;.
	BEQ	LAB_F4FA		;.

	CMP	#$8D			;.
	BNE	LAB_F4C5		;.

	AND	#$7F			;.
LAB_F4FA:
	DEC	LAB_86		;.
	LDX	#$00			;.
	STX	LAB_87		;.
	BEQ	LAB_F4C5		;.


;************************************************************************************
;
; ??

LAB_F502:
	LDX	#$05			;.
	LDY	#$00			;.
	STY	LAB_8F		;.
	STY	LAB_90		;.
LAB_F50A:
	STY	LAB_C5,X		;.
	STY	LAB_CB,X		;.
	LDA	LAB_BF,X		;.
	BMI	LAB_F515		;.

	JMP	LAB_F597		;.

LAB_F515:
	DEC	LAB_C5,X		;.
	DEC	LAB_CB,X		;.
	SEC				; set carry for subtract
	TYA				;.
	SBC	LAB_B9,X		;.
	STA	LAB_B9,X		;.
	TYA				;.
	SBC	LAB_BF,X		;.
	STA	LAB_BF,X		;.
LAB_F524:
	CMP	LAB_90		;.
	BCC	LAB_F538		;.

	BNE	LAB_F530		;.

	LDA	LAB_B9,X		;.
	CMP	LAB_8F		;.
	BCC	LAB_F538		;.

LAB_F530:
	LDA	LAB_B9,X		;.
	STA	LAB_8F		;.
	LDA	LAB_BF,X		;.
	STA	LAB_90		;.
LAB_F538:
	DEX				;.
	BPL	LAB_F50A		;.

	LDA	LAB_90		;.
	STA	LAB_92		;.
	LSR				;.
	TAY				;.
	LDA	LAB_8F		;.
	STA	LAB_91		;.
	ROR				;.
	LDX	#$05			;.
LAB_F548:
	STA	LAB_D1,X		;.
	STY	LAB_D7,X		;.
	DEX				;.
	BPL	LAB_F548		;.

	LDA	LAB_A6		;.
	STA	LAB_A8		;.
	LDA	LAB_A4		;.
	BEQ	LAB_F572		;.

	LDA	LAB_90		;.
	LSR				;.
	BNE	LAB_F563		;.

	LDA	LAB_8F		;.
	ROR				;.
	CMP	#$40			;.
	BCC	LAB_F565		;.

LAB_F563:
	LDA	#$40			;.
LAB_F565:
	STA	LAB_A9		;.
	CLC				; clear carry for add
	LDA	LAB_A8		;.
	ADC	#$20			;.
	BCC	LAB_F578		;.

	LDA	#$00			;.
	STA	LAB_A4		;.
LAB_F572:
	STA	LAB_A9		;.
	STA	LAB_A5		;.
	BEQ	LAB_F582		;.

LAB_F578:
	LDY	#$00			;.
	STY	LAB_A5		;.
	STY	LAB_7806		; VIA T1Ll
	JSR	LAB_F848		;..
LAB_F582:
	LDA	#$01			;.
	STA	LAB_80		;.
LAB_F586:
	LDA	LAB_81		;.
	CMP	#$07			;.
	BEQ	LAB_F59C		;.

	LDA	LAB_86		;.
	BNE	LAB_F59C		;.

	LDA	LAB_80		;.
	BNE	LAB_F586		;.

	STA	LAB_A4		;.
	RTS

LAB_F597:
	INC	LAB_C5,X		;.
	JMP	LAB_F524		;.

LAB_F59C:
	STX	LAB_9F		;.
	INX				;.
	STX	LAB_80		;.
	STX	LAB_A4		;.
	RTS


;************************************************************************************
;
; ??

LAB_F5A4:
	.byte	$01,$05,$04,$06	;.
	.byte	$02,$0A,$08,$09	;.


;************************************************************************************
;
; NMI vector

LAB_F5AC:
	BIT	LAB_7804		; VIA T1Cl
	PHA				; save A
	TXA				; copy X
	PHA				; save X
	TYA				; copy Y
	PHA				; save Y
	LDA	LAB_80		;.
	BMI	LAB_F5BB		;.

	JMP	LAB_F63C		;.

LAB_F5BB:
	LDA	#$50			; set IOIO IIII
	STA	LAB_7802		; VIA DDRB
	LDA	LAB_7801		; VIA DRA
	EOR	#$FF			;.
	ASL				;.
	ASL				;.
	LDY	#$00			;.
	LDX	#$05			;.
LAB_F5CB:
	STY	LAB_B9,X		;.
	ASL				;.
	ROL	LAB_B9,X		;.
	DEX				;.
	BPL	LAB_F5CB		;.

	LDA	#$60			; set IOOI IIII
	STA	LAB_7802		; VIA DDRB
	LDA	LAB_7801		; VIA DRA
	ASL				;.
	ASL				;.
	LDX	#$05			;.
LAB_F5DF:
	ASL				;.
	BCS	LAB_F5E4		;.

	DEC	LAB_B9,X		;.
LAB_F5E4:
	DEX				;.
	BPL	LAB_F5DF		;.

	SEC				; set carry for subtract
	LDA	LAB_BB		;.
	SBC	LAB_BE		;.
	STA	LAB_BE		;.
	CLC				; clear carry for add
	LDA	LAB_BC		;.
	TAX				;.
	ADC	LAB_BD		;.
	STA	LAB_BC		;.
	SEC				; set carry for subtract
	TXA				;.
	SBC	LAB_BD		;.
	STA	LAB_BD		;.
	LDX	#$05			;.
LAB_F5FE:
	LDA	LAB_B9,X		;.
	BEQ	LAB_F636		;.

	BMI	LAB_F617		;.

	LDY	LAB_80		;.
	INY				;.
	BNE	LAB_F60E		;.

	INC	LAB_DD,X		;.
	JMP	LAB_F629		;.

LAB_F60E:
	INC	LAB_AD,X		;.
	BNE	LAB_F629		;.

	INC	LAB_B3,X		;.
	JMP	LAB_F629		;.

LAB_F617:
	LDY	LAB_80		;.
	INY				;.
	BNE	LAB_F621		;.

	DEC	LAB_DD,X		;.
	JMP	LAB_F629		;.

LAB_F621:
	LDA	LAB_AD,X		;.
	BNE	LAB_F627		;.

	DEC	LAB_B3,X		;.
LAB_F627:
	DEC	LAB_AD,X		;.
LAB_F629:
	LDA	LAB_AD,X		;.
	CLC				; clear carry for add
	ADC	LAB_DD,X		;.
	AND	#$07			;.
	TAY				;.
	LDA	LAB_F5A4,Y		;.
	STA	LAB_E3,X		;.
LAB_F636:
	DEX				;.
	BPL	LAB_F5FE		;.

	JMP	LAB_F6C5		;.

LAB_F63C:
	BEQ	LAB_F648		;.

	LDX	LAB_91		;.
	BNE	LAB_F64D		;.

	LDA	LAB_92		;.
	BNE	LAB_F64B		;.

	STA	LAB_80		;.
LAB_F648:
	JMP	LAB_F6E9		;.

LAB_F64B:
	DEC	LAB_92		;.
LAB_F64D:
	DEC	LAB_91		;.
	LDA	LAB_A4		;.
	BEQ	LAB_F68A		;.

	LDA	LAB_92		;.
	BNE	LAB_F65B		;.

	CPX	LAB_A9		;.
	BEQ	LAB_F675		;.

LAB_F65B:
	LDA	LAB_A6		;.
	CMP	LAB_A8		;.
	BNE	LAB_F665		;.

	LDA	LAB_A5		;.
	BEQ	LAB_F68A		;.

LAB_F665:
	SEC				; set carry for subtract
	LDA	LAB_A5		;.
	SBC	#$80			;.
	STA	LAB_A5		;.
	STA	LAB_7806		; VIA T1Ll
	LDA	LAB_A6		;.
	SBC	#$00			;.
	BNE	LAB_F684		;.

LAB_F675:
	DEC	LAB_A9		;.
	LDA	LAB_A5		;.
	ADC	#$7F			;.
	STA	LAB_A5		;.
	STA	LAB_7806		; VIA T1Ll
	LDA	LAB_A6		;.
	ADC	#$00			;.
LAB_F684:
	STA	LAB_7807		; VIA T1Lh
	JSR	LAB_F84B		;..
LAB_F68A:
	LDX	#$05			; set the ?? count/index
LAB_F68C:
	LDA	LAB_D1,X		;.
	SEC				; set carry for subtract
	SBC	LAB_B9,X		;.
	STA	LAB_D1,X		;.
	LDA	LAB_D7,X		;.
	SBC	LAB_BF,X		;.
	STA	LAB_D7,X		;.
	BPL	LAB_F6C2		;.

	CLC				; clear carry for add
	LDA	LAB_D1,X		;.
	ADC	LAB_8F		;.
	STA	LAB_D1,X		;.
	LDA	LAB_D7,X		;.
	ADC	LAB_90		;.
	STA	LAB_D7,X		;.
	CLC				; clear carry for add
	LDA	LAB_AD,X		;.
	ADC	LAB_C5,X		;.
	STA	LAB_AD,X		;.
	TAY				;.
	LDA	LAB_B3,X		;.
	ADC	LAB_CB,X		;.
	STA	LAB_B3,X		;.
	TYA				;.
	CLC				; clear carry for add
	ADC	LAB_DD,X		;.
	AND	#$07			;.
	TAY				;.
	LDA	LAB_F5A4,Y		;.
	STA	LAB_E3,X		;.
LAB_F6C2:
	DEX				; decrement the ?? count/index
	BPL	LAB_F68C		; loop if more to do

; set the 74LS174 hex D-type flip flops

LAB_F6C5:
	LDA	LAB_E4		;.
	ASL				;.
	ASL				;.
	ASL				;.
	ASL				;.
	ORA	LAB_E3		;.
	STA	LAB_0800		; save 74LS174 hex D-type flip flop 0
	AND	#$F0			;.
	ORA	LAB_E5		;.
	STA	LAB_0C00		; save 74LS174 hex D-type flip flop 1

	LDA	LAB_E7		;.
	ASL				;.
	ASL				;.
	ASL				;.
	ASL				;.
	ORA	LAB_E6		;.
	STA	LAB_1000		; save 74LS174 hex D-type flip flop 2
	AND	#$F0			;.
	ORA	LAB_E8		;.
	STA	LAB_1400		; save 74LS174 hex D-type flip flop 3
LAB_F6E9:
	DEC	LAB_89		;.
	BNE	LAB_F717		; if ?? restore Y, X and A and return from interrupt

	LDA	LAB_8A		;.
	STA	LAB_89		;.
	LDA	#$60			; set IOOI IIII
	STA	LAB_7802		; VIA DDRB
	LDA	LAB_7801		; VIA DRA
	STA	LAB_A3		;.
	ASL				;.
	LDX	#$0E			;.
LAB_F6FE:
	ASL				;.
	BCC	LAB_F71D		;.

	DEX				;.
	CPX	#$07			;.
	BNE	LAB_F6FE		;.

	LDA	#$50			; set IOIO IIII
	STA	LAB_7802		; VIA DDRB
	LDA	LAB_7801		; VIA DRA
	ASL				;.
LAB_F70F:
	ASL				;.
	BCC	LAB_F71D		;.

	DEX				;.
	BNE	LAB_F70F		;.

	STX	LAB_83		;.
LAB_F717:
	PLA				; pull Y
	TAY				; restore Y
LAB_F719:
	PLA				; pull X
	TAX				; restore X
	PLA				; restore A
	RTI

LAB_F71D:
	LDA	LAB_83		;.
	BNE	LAB_F717		; if ?? restore Y, X and A and return from interrupt

	LDA	LAB_80		;.
	BPL	LAB_F731		;.

	CPX	#$07			;.
	BEQ	LAB_F731		;.

	CPX	#$0E			;.
	BNE	LAB_F717		; if ?? restore Y, X and A and return from interrupt

	CMP	#$F1			;.
	BNE	LAB_F717		; if ?? restore Y, X and A and return from interrupt

LAB_F731:
	STX	LAB_81		;.
	STX	LAB_82		;.
	BPL	LAB_F717		; if ?? restore Y, X and A and return from interrupt


;************************************************************************************
;
; ??

LAB_F737:
	LDY	#$00			;.
	LDA	LAB_9F		;.
	STY	LAB_9F		;.
	BNE	LAB_F742		;.

	JSR	LAB_F1CF		; increment the LAB_8D pointer by $000E ??
LAB_F742:
	LDA	(LAB_8D),Y		;.
	CMP	#$07			;.
	BEQ	LAB_F74E		;.

	CMP	#$01			;.
	BNE	LAB_F77A		;.

	STA	LAB_A4		;.
LAB_F74E:
	INY				;.
	LDA	(LAB_8D),Y		;.
	JSR	LAB_F848		;..
	LDY	#$07			;.
LAB_F756:
	SEC				; set carry for subtract
	LDA	(LAB_8D),Y		;.
	SBC	LAB_00AB,Y		;.
	STA	LAB_00B7,Y		;.
	TYA				;.
	PHP				;.
	CLC				; clear carry for add
	ADC	#$06			;.
	TAY				;.
	PLP				;.
	LDA	(LAB_8D),Y		;.
	SBC	LAB_00AB,Y		;.
	STA	LAB_00B7,Y		;.
	TYA				;.
	SEC				; set carry for subtract
	SBC	#$07			;.
	TAY				;.
	CMP	#$01			;.
	BNE	LAB_F756		;.

	JMP	LAB_F502		;..

LAB_F77A:
	CMP	#$03			;.
	BNE	LAB_F7DE		;.

	INY				;.
	LDA	(LAB_8D),Y		;.
	CMP	#$08			;.
	BEQ	LAB_F7DD		; if ?? just exit

	BCS	LAB_F78D		;.

	TAX				;.
	LDA	LAB_1800,X		; read the 74LS251 data selector bit X
	BMI	LAB_F7DD		; if the bit = 1 just exit

LAB_F78D:
	LDY	#$03			;.
	LDA	(LAB_8D),Y		;.
	TAX				;.
	DEY				;.
	LDA	(LAB_8D),Y		;.
	STY	LAB_9F		;.


;************************************************************************************
;
; ??

LAB_F797:
	STX	LAB_8E		;.
	ASL				;.
	ROL	LAB_8E		;.
	STA	LAB_8D		;.
	ASL				;.
	TAY				;.
	LDA	LAB_8E		;.
	ROL				;.
	TAX				;.
	TYA				;.
	ADC	LAB_8D		;.
	STA	LAB_8D		;.
	TXA				;.
	ADC	LAB_8E		;.
	STA	LAB_8E		;.
	TYA				;.
	ASL				;.
	TAY				;.
	TXA				;.
	ROL				;.
	TAX				;.
	TYA				;.
	ADC	LAB_8D		;.
	TAY				;.
	TXA				;.
	ADC	LAB_8E		;.
	TAX				;.
	TYA				;.
	ADC	#$1A			;.
	STA	LAB_8D		;.
	TAY				;.
	TXA				;.
	ADC	#$01			;.
	STA	LAB_8E		;.
	TAX				;.
	CMP	#$07			;.
	BCC	LAB_F7DD		; if ?? just exit

	BNE	LAB_F7D3		;.

	TYA				;.
	CMP	#$FE			;.
	BCC	LAB_F7DD		; if ?? just exit

LAB_F7D3:
	TYA				;.
	ADC	#$34			;.
	STA	LAB_8D		;.
	TXA				;.
	ADC	#$F2			;.
	STA	LAB_8E		;.
LAB_F7DD:
	RTS

LAB_F7DE:
	CMP	#$02			;.
	BNE	LAB_F7EB		;.

	INY				;.
	LDA	(LAB_8D),Y		;.
	JSR	LAB_F848		;..
	JMP	LAB_F96D		;..

LAB_F7EB:
	CMP	#$05			;.
	BNE	LAB_F7F9		;.

	INY				;.
	LDA	(LAB_8D),Y		;.
	TAX				;.
	INY				;.
	LDA	(LAB_8D),Y		;.
	JMP	LAB_F1B4		;..

LAB_F7F9:
	CMP	#$04			;.
	BNE	LAB_F835		;.

	STY	LAB_91		;.
	STY	LAB_92		;.
	STY	LAB_95		;.
	INY				;.
	LDA	(LAB_8D),Y		;.
	LSR				;.
	ROR	LAB_94		;.
	LSR				;.
	ROR	LAB_94		;.
	LSR				;.
	ROR	LAB_94		;.
	STA	LAB_95		;.
	LDA	#$E0			;.
	JSR	LAB_F848		;..
LAB_F816:
	LDA	#$01			;.
	STA	LAB_80		;.
LAB_F81A:
	LDA	LAB_80		;.
	BNE	LAB_F81A		;.

	LDA	LAB_94		;.
	BNE	LAB_F828		;.

	LDA	LAB_95		;.
	BEQ	LAB_F834		;.

	DEC	LAB_95		;.
LAB_F828:
	DEC	LAB_94		;.
	LDA	LAB_81		;.
	CMP	#$07			;.
	BEQ	LAB_F834		;.

	LDA	LAB_86		;.
	BEQ	LAB_F816		;.

LAB_F834:
	RTS

LAB_F835:
	CMP	#$06			;.
	BNE	LAB_F834		;.

LAB_F839:
	INY				;.
	STY	LAB_9B		;.
	LDA	(LAB_8D),Y		;.
	BEQ	LAB_F834		;.

	TAX				;.
	JSR	LAB_F8FC		; send ACIA A byte with delay
	LDY	LAB_9B		;.
	BNE	LAB_F839		;.


;************************************************************************************
;
; ??

LAB_F848:
	STA	LAB_7805		; VIA T1Ch


;************************************************************************************
;
; ??

LAB_F84B:
	STA	LAB_A6		;.
	EOR	#$FF			;.
	LSR				;.
	LSR				;.
	LSR				;.
	LSR				;.
	LSR				;.
	ORA	#$01			;.
	STA	LAB_8A		;.
	RTS


;************************************************************************************
;
; ??

LAB_F859:
	LDA	#$00			;.
	STA	LAB_97		;.
	STA	LAB_98		;.
	STA	LAB_99		;.
	STA	LAB_9C		;.
LAB_F863:
	JSR	LAB_F9B3		; get a byte from the buffer ??
	CMP	LAB_88		;.
	BEQ	LAB_F88D		;.

	AND	#$7F			; mask 0xxx xxxx, 7 bit ASCII
	CMP	#$0D			; compare it with [CR]
	BEQ	LAB_F8A3		;.

	CMP	#','			; compare it with ","
	BEQ	LAB_F8AB		;.

	CMP	#'-'			; compare it with "-"
	BNE	LAB_F87C		;.

	STA	LAB_99		;.
	BEQ	LAB_F863		;.

LAB_F87C:
	CMP	#'0'			; compare it with "0"
	BCC	LAB_F863		;.

	CMP	#'9'+1		; compare it with "9" + 1
	BCS	LAB_F863		;.

	BCC	LAB_F8C7		;., branch always

LAB_F886:
	JSR	LAB_F9B3		; get a byte from the buffer ??
	CMP	LAB_88		;.
	BNE	LAB_F895		;.

LAB_F88D:
	LDX	#'0'			; set "0"
	JSR	LAB_F481		;..
	JMP	LAB_F0BE		; return to the start of the main loop ??

LAB_F895:
	AND	#$7F			; mask 0xxx xxxx, 7 bit ASCII
	CMP	#','			; compare it with ","
	BEQ	LAB_F8AB		;.

	CMP	#' '			; compare it with " "
	BEQ	LAB_F8AB		;.

	CMP	#$0D			; compare it with [CR]
	BNE	LAB_F8BF		;.

LAB_F8A3:
	LDA	LAB_8C		; get the Rx buffer read index
	SBC	#$01			;.
	AND	#$7F			;.
	STA	LAB_8C		; save the Rx buffer read index
LAB_F8AB:
	LDA	LAB_99		;.
	BEQ	LAB_F8BA		;.

	SEC				; set carry for subtract
	LDA	#$00			;.
	SBC	LAB_97		;.
	TAY				;.
	LDA	#$00			;.
	SBC	LAB_98		;.
	RTS

LAB_F8BA:
	LDY	LAB_97		;.
	LDA	LAB_98		;.
	RTS

LAB_F8BF:
	CMP	#'0'			; compare it with "0"
	BCC	LAB_F886		;.

	CMP	#'9'+1		; compare it with "9" + 1
	BCS	LAB_F886		;.

LAB_F8C7:
	STA	LAB_9C		;.
	SBC	#$2F			;.
	ASL	LAB_97		;.
	ROL	LAB_98		;.
	ADC	LAB_97		;.
	TAY				;.
	LDA	LAB_98		;.
	ADC	#$00			;.
	TAX				;.
	ASL	LAB_97		;.
	ROL	LAB_98		;.
	ASL	LAB_97		;.
	ROL	LAB_98		;.
	CLC				; clear carry for add
	TYA				;.
	ADC	LAB_97		;.
	STA	LAB_97		;.
	TXA				;.
	ADC	LAB_98		;.
	STA	LAB_98		;.
	JMP	LAB_F886		;.


;************************************************************************************
;
; ??

LAB_F8ED:
	JSR	LAB_F859		;..
	TYA				;.
	LDY	LAB_9C		;.
	BNE	LAB_F8F7		;.

	LDA	#$E5			;.
LAB_F8F7:
	EOR	#$FF			;.
	JMP	LAB_F848		;..


;************************************************************************************
;
; send ACIA A byte with delay

LAB_F8FC:
	LDY	LAB_A2		;.
	INY				;.
	TXA				;.
	LDX	#$01			;.
LAB_F902:
	DEX				;.
	BNE	LAB_F902		;.

	DEY				;.
	BNE	LAB_F902		;.

	TAX				; copy the Tx data byte


;************************************************************************************
;
; send ACIA A byte

LAB_F909:
	LDA	#$02			; mask 0000 00x0, ACIA A Tx status bit
LAB_F90B:
	BIT	LAB_4800		; test the ACIA A Tx status bit
	BEQ	LAB_F90B		; loop while the Tx buffer is full

	STX	LAB_4801		; save the ACIA A Tx data byte
	RTS


;************************************************************************************
;
; ??

LAB_F914:
	LDX	#$01			;.
	STX	LAB_1C00		;.
	DEX				;.
	STX	LAB_84		;.
	STX	LAB_85		;.
LAB_F91E:
	LDA	LAB_83		;.
	BNE	LAB_F91E		;.

	LDA	#$40			;.
	STA	LAB_7800		; VIA DRB
	JSR	LAB_F99E		;..
	TAX				;.
	LDA	#$00			;.
	STA	LAB_7800		; VIA DRB
	LDA	LAB_86		;.
	BNE	LAB_F948		;.

	LDA	LAB_F01E-1,X	;.
	BPL	LAB_F94B		;.

	CMP	#$FE			;.
	BEQ	LAB_F914		;.

	CMP	#$FB			;.
	BEQ	LAB_F948		;.

	LDA	#$40			;.
	STA	LAB_7800		; VIA DRB
	BNE	LAB_F91E		;.

LAB_F948:
	LDA	LAB_84		;.
	RTS

LAB_F94B:
	ASL	LAB_84		;.
	ROL	LAB_85		;.
	ADC	LAB_84		;.
	TAY				;.
	LDA	LAB_85		;.
	ADC	#$00			;.
	TAX				;.
	ASL	LAB_84		;.
	ROL	LAB_85		;.
	ASL	LAB_84		;.
	ROL	LAB_85		;.
	CLC				; clear carry for add
	TYA				;.
	ADC	LAB_84		;.
	STA	LAB_84		;.
	TXA				;.
	ADC	LAB_85		;.
	STA	LAB_85		;.
	JMP	LAB_F91E		;.


;************************************************************************************
;
; ??

LAB_F96D:
	LDA	#$20			;.


;************************************************************************************
;
; ??

LAB_F96F:
	STA	LAB_96		;.
	BIT	LAB_1800		; read the 74LS251 data selector bit 0
	BMI	LAB_F97F		;.

LAB_F976:
	BIT	LAB_1800		; read the 74LS251 data selector bit 0
	BPL	LAB_F980		;.

	DEC	LAB_96		;.
	BNE	LAB_F980		;.

LAB_F97F:
	RTS

LAB_F980:
	LDX	#$0B			; set the byte count/index
	LDA	#$00			; clear A
LAB_F984:
	STA	LAB_B9,X		;.
	DEX				; decrement the byte count/index
	BPL	LAB_F984		; loop if more to do

	STX	LAB_BE		;.
	STX	LAB_C4		;.
	JSR	LAB_F502		;..
	CMP	#$07			;.
	BNE	LAB_F976		;.

	RTS


;************************************************************************************
;
; set LAB_8D pointer to LAB_011A ??

LAB_F995:
	LDA	#<LAB_011A		; ?? low byte
	STA	LAB_8D		;.
	LDA	#>LAB_011A		; ?? high byte
	STA	LAB_8E		;.
	RTS


;************************************************************************************
;
; ??

LAB_F99E:
	JSR	LAB_F9A8		;..
	BNE	LAB_F9B2		;.

	LDX	LAB_86		;.
	BEQ	LAB_F99E		;.

	RTS


;************************************************************************************
;
; ??

LAB_F9A8:
	LDX	#$00			;.
	LDA	LAB_81		;.
	BEQ	LAB_F9B2		;.

	STA	LAB_83		;.
	STX	LAB_81		;.
LAB_F9B2:
	RTS


;************************************************************************************
;
; get a byte from the buffer ??

LAB_F9B3:
	LDX	LAB_8C		; get the Rx buffer read index
	LDA	LAB_00,X		; get an Rx buffer byte
	INX				; increment the Rx buffer read index
	BPL	LAB_F9BC		; if < $80 continue

	LDX	#$00			; else reset the index to the start
LAB_F9BC:
	STX	LAB_8C		; save the Rx buffer read index
LAB_F9BE:
	RTS


;************************************************************************************
;
; ??

LAB_F9BF:
	LDX	#$00			;.
	STX	LAB_9C		;.
	STY	LAB_97		;.
	STA	LAB_98		;.
	TAY				;.
	BPL	LAB_F9DA		;.

	TXA				;.
	SEC				; set carry for subtract
	SBC	LAB_97		;.
	STA	LAB_97		;.
	TXA				;.
	SBC	LAB_98		;.
	STA	LAB_98		;.
	LDX	#'-'			; set "-"
	JSR	LAB_F8FC		; send ACIA A byte with delay
LAB_F9DA:
	LDY	#$10			;.
	LDA	#$27			;.
	JSR	LAB_FA03		;..
	LDY	#$E8			;.
	LDA	#$03			;.
	JSR	LAB_FA03		;..
	LDY	#$64			;.
	LDA	#$00			;.
	JSR	LAB_FA03		;..
	LDY	#$0A			;.
	LDA	#$00			;.
	JSR	LAB_FA03		;..
	LDY	#$01			;.
	LDA	#$00			;.
	JSR	LAB_FA03		;..
	LDA	LAB_9C		;.
	BNE	LAB_F9BE		;.

	BEQ	LAB_FA30		;., branch always


;************************************************************************************
;
; ??

LAB_FA03:
	LDX	#$30			;.
	STY	LAB_9D		;.
	STA	LAB_9E		;.
LAB_FA09:
	SEC				; set carry for subtract
	LDA	LAB_97		;.
	SBC	LAB_9D		;.
	STA	LAB_97		;.
	LDA	LAB_98		;.
	SBC	LAB_9E		;.
	STA	LAB_98		;.
	BMI	LAB_FA1B		;.

	INX				;.
	BNE	LAB_FA09		;.

LAB_FA1B:
	TYA				;.
	ADC	LAB_97		;.
	STA	LAB_97		;.
	LDA	LAB_98		;.
	ADC	LAB_9E		;.
	STA	LAB_98		;.
	CPX	#$30			;.
	BNE	LAB_FA2E		;.

	LDA	LAB_9C		;.
	BEQ	LAB_F9BE		;.

LAB_FA2E:
	STX	LAB_9C		;.
LAB_FA30:
	JMP	LAB_F8FC		; send ACIA A byte with delay and return


;************************************************************************************
;
; ??

;LAB_FA33:
	.byte	$01,$10,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
;LAB_FA40:
	.byte	$00,$01,$11,$00,$37,$C6,$00,$00,$C6,$00,$FF,$FF,$00,$00,$FF,$01
;LAB_FA50:
	.byte	$10,$04,$EB,$BB,$00,$00,$BB,$F9,$FC,$FE,$00,$00,$FE,$01,$10,$04
;LAB_FA60:
	.byte	$B9,$4C,$00,$00,$4C,$F9,$02,$FC,$00,$00,$FC,$01,$11,$04,$31,$C5
;LAB_FA70:
	.byte	$1B,$E9,$C5,$F9,$FB,$F7,$FA,$FF,$F7,$01,$0C,$04,$31,$C5,$1B,$E9
;LAB_FA80:
	.byte	$5C,$F9,$FB,$F7,$FA,$FF,$FB,$02,$0E,$A0,$B3,$A0,$A0,$C5,$B1,$A0
;LAB_FA90:
	.byte	$B7,$A0,$A0,$A0,$A0,$04,$02,$C1,$A0,$A0,$B7,$A0,$A0,$AC,$B9,$A0
;LAB_FAA0:
	.byte	$A0,$A0,$A0,$01,$10,$04,$85,$48,$69,$37,$30,$F9,$FD,$F9,$F9,$FF
;LAB_FAB0:
	.byte	$F9,$01,$0E,$EC,$96,$45,$04,$F4,$2D,$06,$02,$FC,$03,$FC,$FC,$01
;LAB_FAC0:
	.byte	$11,$EC,$33,$E5,$04,$F4,$CD,$06,$FE,$FE,$03,$FC,$FE,$01,$10,$00
;LAB_FAD0:
	.byte	$33,$8A,$0C,$EC,$72,$00,$FE,$FF,$00,$FF,$FF,$01,$10,$00,$19,$C5
;LAB_FAE0:
	.byte	$0C,$EC,$AD,$00,$FF,$FF,$00,$FF,$FF,$01,$32,$00,$00,$00,$00,$00
;LAB_FAF0:
	.byte	$00,$00,$00,$00,$00,$00,$00,$01,$11,$00,$00,$00,$00,$00,$76,$00
;LAB_FB00:
	.byte	$FF,$00,$00,$00,$04,$01,$10,$00,$97,$23,$AD,$AD,$99,$00,$00,$FE
;LAB_FB10:
	.byte	$00,$00,$02,$01,$0E,$00,$97,$23,$AD,$AD,$FD,$00,$00,$FE,$00,$00
;LAB_FB20:
	.byte	$FF,$03,$00,$A7,$00,$A0,$C4,$B1,$A0,$BF,$A0,$80,$A0,$C6,$B1,$01
;LAB_FB30:
	.byte	$17,$00,$6E,$23,$AD,$AD,$FD,$00,$FF,$FE,$00,$00,$FF,$01,$10,$00
;LAB_FB40:
	.byte	$06,$02,$26,$41,$DC,$00,$FE,$FF,$02,$FC,$00,$01,$11,$00,$1F,$C1
;LAB_FB50:
	.byte	$3D,$53,$96,$00,$00,$FF,$02,$FC,$01,$01,$0C,$00,$1F,$C1,$3D,$53
;LAB_FB60:
	.byte	$48,$00,$00,$FF,$02,$FC,$02,$01,$13,$00,$80,$CE,$F0,$06,$55,$00
;LAB_FB70:
	.byte	$FF,$FE,$02,$FD,$01,$01,$0E,$00,$80,$CE,$F0,$06,$BA,$00,$FF,$FE
;LAB_FB80:
	.byte	$02,$FD,$00,$01,$11,$00,$A6,$05,$F0,$06,$A1,$00,$FE,$FE,$02,$FD
;LAB_FB90:
	.byte	$FF,$01,$13,$C5,$12,$F8,$8E,$72,$D7,$FD,$00,$FD,$02,$FD,$FF,$07
;LAB_FBA0:
	.byte	$1C,$29,$EB,$1E,$A4,$5C,$FD,$FE,$FF,$FE,$02,$FD,$FF,$07,$10,$96
;LAB_FBB0:
	.byte	$CE,$3C,$BB,$45,$1B,$FE,$FF,$FE,$02,$FD,$00,$07,$10,$0A,$BA,$52
;LAB_FBC0:
	.byte	$D4,$2C,$31,$FF,$FF,$FE,$02,$FD,$00,$07,$10,$83,$AE,$60,$EF,$11
;LAB_FBD0:
	.byte	$3F,$FF,$FF,$FE,$02,$FD,$00,$07,$10,$00,$AB,$64,$0A,$F6,$43,$00
;LAB_FBE0:
	.byte	$FF,$FE,$03,$FC,$00,$07,$10,$7D,$AE,$60,$25,$DB,$3F,$00,$FF,$FE
;LAB_FBF0:
	.byte	$03,$FC,$00,$07,$10,$F6,$BA,$52,$40,$C0,$31,$00,$FF,$FE,$03,$FC
;LAB_FC00:
	.byte	$00,$07,$10,$6A,$CE,$3C,$59,$A7,$1B,$01,$FF,$FE,$03,$FC,$00,$07
;LAB_FC10:
	.byte	$10,$D7,$EB,$1C,$70,$90,$FD,$01,$FF,$FE,$03,$FC,$FF,$07,$1C,$3B
;LAB_FC20:
	.byte	$12,$F8,$86,$7A,$D7,$02,$00,$FD,$03,$FC,$FF,$01,$13,$00,$66,$F0
;LAB_FC30:
	.byte	$73,$83,$DC,$00,$FE,$FD,$01,$FE,$FF,$01,$10,$00,$86,$BE,$73,$83
;LAB_FC40:
	.byte	$AA,$00,$FF,$FE,$01,$FE,$00,$01,$0C,$00,$86,$BE,$73,$83,$07,$00
;LAB_FC50:
	.byte	$FF,$FE,$01,$FE,$02,$01,$13,$00,$8D,$60,$73,$83,$A9,$00,$FC,$FD
;LAB_FC60:
	.byte	$01,$FE,$00,$03,$09,$7E,$00,$BA,$A0,$A0,$A0,$CF,$A0,$A0,$A0,$B0
;LAB_FC70:
	.byte	$A4,$01,$11,$00,$46,$D2,$78,$78,$3F,$00,$FE,$FC,$FE,$FE,$FD,$01
;LAB_FC80:
	.byte	$13,$00,$46,$D2,$13,$13,$3F,$00,$FE,$FC,$FE,$FE,$FD,$01,$10,$00
;LAB_FC90:
	.byte	$46,$D2,$A8,$A8,$3F,$00,$FE,$FC,$FE,$FE,$FD,$01,$11,$00,$46,$D2
;LAB_FCA0:
	.byte	$17,$17,$3F,$00,$FE,$FC,$FE,$FE,$FD,$01,$10,$00,$46,$D2,$95,$95
;LAB_FCB0:
	.byte	$3F,$00,$FE,$FC,$FE,$FE,$FD,$01,$13,$00,$67,$0C,$00,$00,$0C,$00
;LAB_FCC0:
	.byte	$FD,$FE,$00,$00,$FE,$03,$09,$7E,$00,$A0,$A0,$A0,$B6,$80,$A0,$80
;LAB_FCD0:
	.byte	$A0,$A0,$A0,$01,$10,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
;LAB_FCE0:
	.byte	$00,$04,$04,$A0,$C4,$A0,$B8,$BA,$A0,$A0,$A0,$A0,$C5,$A0,$A0,$01
;LAB_FCF0:
	.byte	$13,$2B,$18,$1D,$A9,$57,$18,$FE,$FE,$FE,$FF,$00,$02,$01,$10,$6C
;LAB_FD00:
	.byte	$C1,$9A,$A9,$57,$44,$FE,$FF,$FE,$FF,$00,$01,$01,$0E,$6C,$C1,$9A
;LAB_FD10:
	.byte	$A9,$57,$4C,$FE,$FF,$FE,$FF,$00,$00,$03,$00,$C0,$00,$B3,$A0,$C6
;LAB_FD20:
	.byte	$A4,$A0,$C4,$A0,$A0,$A0,$C5,$01,$17,$00,$6F,$D4,$09,$03,$86,$00
;LAB_FD30:
	.byte	$FD,$FD,$00,$00,$FF,$01,$10,$00,$95,$C5,$15,$EB,$77,$00,$FF,$FE
;LAB_FD40:
	.byte	$00,$FF,$00,$01,$0C,$00,$95,$C5,$15,$EB,$54,$00,$FF,$FE,$00,$FF
;LAB_FD50:
	.byte	$02,$01,$13,$00,$6F,$D4,$09,$03,$86,$00,$FD,$FD,$00,$00,$FF,$01
;LAB_FD60:
	.byte	$10,$89,$A7,$85,$57,$A9,$63,$01,$FF,$FE,$00,$FF,$01,$01,$0E,$89
;LAB_FD70:
	.byte	$CA,$94,$4E,$B2,$A7,$01,$FF,$FE,$00,$FF,$FF,$03,$00,$BE,$00,$C6
;LAB_FD80:
	.byte	$A0,$A0,$A0,$A0,$A0,$C4,$A0,$9D,$D0,$01,$17,$00,$2F,$C6,$00,$00
;LAB_FD90:
	.byte	$DE,$00,$FD,$FD,$00,$00,$FE,$01,$10,$00,$CC,$86,$F6,$05,$99,$00
;LAB_FDA0:
	.byte	$FE,$FE,$FF,$00,$FF,$01,$0C,$00,$CC,$86,$F6,$05,$CE,$00,$FE,$FE
;LAB_FDB0:
	.byte	$FF,$00,$00,$01,$13,$00,$9D,$B6,$00,$00,$06,$00,$FC,$FE,$00,$00
;LAB_FDC0:
	.byte	$02,$03,$09,$AE,$00,$A0,$BA,$A0,$A0,$B3,$A0,$A0,$B2,$B0,$B7,$01
;LAB_FDD0:
	.byte	$13,$2B,$18,$1D,$A9,$57,$18,$FE,$FE,$FE,$FF,$00,$02,$01,$11,$64
;LAB_FDE0:
	.byte	$D1,$ED,$57,$A9,$C6,$01,$FD,$FD,$00,$FF,$00,$01,$10,$91,$A7,$85
;LAB_FDF0:
	.byte	$63,$9D,$F4,$01,$FF,$FE,$00,$FF,$01,$01,$0E,$91,$A7,$85,$63,$9D
;LAB_FE00:
	.byte	$50,$01,$FF,$FE,$00,$FF,$00,$03,$00,$BE,$00,$A0,$A0,$A0,$A0,$B6
;LAB_FE10:
	.byte	$AC,$A0,$B7,$A0,$A0,$01,$17,$00,$6F,$D4,$09,$03,$86,$00,$FD,$FD
;LAB_FE20:
	.byte	$00,$00,$FF,$01,$10,$00,$95,$C5,$00,$00,$77,$00,$FF,$FE,$00,$00
;LAB_FE30:
	.byte	$00,$01,$0C,$00,$95,$C5,$00,$00,$76,$00,$FF,$FE,$00,$00,$01,$01
;LAB_FE40:
	.byte	$13,$F5,$28,$A0,$06,$FA,$DB,$FF,$FD,$FD,$00,$FF,$00,$01,$10,$4E
;LAB_FE50:
	.byte	$C1,$9A,$A9,$57,$44,$FE,$FF,$FE,$FF,$00,$01,$01,$0E,$4E,$C1,$9A
;LAB_FE60:
	.byte	$A9,$57,$AD,$FE,$FF,$FE,$FF,$00,$FF,$03,$09,$BA,$00,$AC,$A0,$B1
;LAB_FE70:
	.byte	$C4,$B4,$A0,$B1,$A0,$C6,$B5,$B4,$A0,$B4,$A0,$A0,$BA,$A0,$B8,$A0
;LAB_FE80:
	.byte	$C5,$A0,$A0,$A0,$A0,$BA,$B1,$D3,$B4,$B6,$A0,$B7,$A0,$A0,$A0,$A0
;LAB_FE90:
	.byte	$A0,$B4,$A0,$BC,$A0,$BF,$A0,$A0,$B2,$A0,$BE,$A0,$AE,$A0,$C2,$B0
;LAB_FEA0:
	.byte	$A0,$B5,$A4,$A0,$A0,$A0,$A0,$A0,$B1,$B1,$C6,$A0,$B6,$A0,$A0,$A0
;LAB_FEB0:
	.byte	$C1,$81,$A0,$BF,$A0,$A0,$A0,$A0,$B4,$A0,$A0,$A0,$A0,$BA,$A0,$C2
;LAB_FEC0:
	.byte	$A0,$C5,$A0,$A0,$A0,$B1,$BA,$B1,$D3,$A0,$A0,$A0,$A0,$A0,$D2,$A0
;LAB_FED0:
	.byte	$A0,$C1,$B4,$A0,$BF,$A0,$80,$A0,$A0,$B3,$A0,$BE,$A0,$A0,$D5,$A0
;LAB_FEE0:
	.byte	$B1,$D0,$C6,$A0,$AD,$D0,$A0,$A0,$A0,$B7,$A0,$C6,$A0,$A0,$A0,$A0
;LAB_FEF0:
	.byte	$A0,$A0,$81,$D9,$C6,$A0,$A0,$A0,$A0,$B4,$A0,$C6,$A0,$B0,$A0,$A0
;LAB_FF00:
	.byte	$C4,$B2,$A0,$BF,$A0,$80,$A0,$A0,$B0,$A0,$C6,$A4,$A0,$CD,$A0,$A0
;LAB_FF10:
	.byte	$AE,$C6,$A0,$C6,$D4,$A0,$BB,$D6,$A0,$A0,$A0,$A0,$84,$A0,$A0,$A0
;LAB_FF20:
	.byte	$A0,$80,$A0,$BF,$A0,$A0,$BA,$B3,$C4,$CD,$C5,$A0,$CA,$C6,$A0,$BA
;LAB_FF30:
	.byte	$A0,$A0,$B4,$A0,$A0,$B4,$A0,$A0,$A0,$B1,$A0,$B4,$A0,$A0,$A0,$A0
;LAB_FF40:
	.byte	$A0,$C6,$B2,$A0,$BF,$A0,$80,$A0,$AE,$B1,$A0,$A0,$A0,$AC,$C4,$A0
;LAB_FF50:
	.byte	$A0,$C2,$B0,$C6,$C6,$A0,$A0,$BB,$A0,$A0,$A0,$A0,$A0,$A3,$A0,$A0
;LAB_FF60:
	.byte	$A0,$A0,$FF,$A0,$A0,$A0,$A0,$BA,$B3,$C6,$CD,$A0,$A0,$A0,$A0,$A0
;LAB_FF70:
	.byte	$BA,$A0,$AC,$B4,$A0,$A0,$B5,$A0,$A0,$A0,$B1,$A0,$B4,$A0,$A0,$A0
;LAB_FF80:
	.byte	$80,$A0,$C6,$B2,$BB,$BF,$A0,$FF,$A0,$C2,$B1,$A0,$A0,$A0,$A0,$C4
;LAB_FF90:
	.byte	$A0,$A0,$C2,$A0,$C6,$C6,$A0,$A0,$A0,$A0,$A0,$A0,$81,$A0,$E0,$D0
;LAB_FFA0:
	.byte	$A0,$A0,$D4,$FF,$A0,$AE,$A0,$A0,$BA,$A0,$B2,$A0,$A0,$A0,$A0,$A0
;LAB_FFB0:
	.byte	$A0,$BA,$A0,$A0,$B4,$A0,$A0,$B5,$A0,$A0,$A0,$A0,$A0,$A0,$A0,$A0
;LAB_FFC0:
	.byte	$A0,$80,$A0,$A0,$B2,$BB,$80,$D2,$FF,$A0,$C2,$A0,$A0,$B1,$A0,$AC
;LAB_FFD0:
	.byte	$C4,$C1,$A0,$A0,$A0,$A0,$C6,$A0,$C5,$A0,$A0,$A0,$A0,$81,$A0,$E0
;LAB_FFE0:
	.byte	$A0,$A0,$A0,$D4,$BF,$A0,$AE,$A0,$A0,$BA,$A0,$B2,$A0,$CC,$A0,$A0
;LAB_FFF0:
	.byte	$A0,$A0,$BA,$D7,$A0,$B4,$D9,$A0,$B6,$B0

;LAB_FFFA:
	.word	LAB_F5AC		; NMI vector
	.word	LAB_F03C		; RESET vector
	.word	LAB_F499		; IRQ vector

	.END


;************************************************************************************
